[C++]LeetCode: 39 Container With Most Water

题目:

Given n non-negative integers a1a2, ..., an, where each represents a point at coordinate (iai). n vertical lines are drawn such that the two endpoints of line i is at (iai) and (i, 0). Find two lines, which together with x-axis forms a container, such that the container contains the most water.

Note: You may not slant the container.

思路:求给定的n个高度两两能构成的最大面积。
        S = min(ai, aj) * |i - j| (假定contaniner不是倾斜的 即取最短的高)

解法一:大家都可以想到,穷举所有(i, j)可能,找一个最大的。

无法通过LeetCode,超时。算法复杂度O(N^2)

Code:

class Solution {
public:
    int maxArea(vector<int> &height) {
        //求给定的n个高度两两能构成的最大面积。
        // S = (ai + aj) * |i - j| /2  
        int s;
        int n = height.size();
        s = (height[0] + height[1]) * 1 / 2;
        
        for(int i = 0; i < n; i++)
        {
            for(int j = i + 1; j < n; j++)
            {
                int tmp = (height[j] + height[i]) * (j - i) / 2;
                if(tmp > s)
                    s = tmp;
            }
        }      
        return s; 
    }
};

解法二:O(n)的复杂度

思路: 图解~~

[C++]LeetCode: 39 Container With Most Water_第1张图片

保持两个指针i,j;分别指向长度数组的首尾。如果ai 小于aj,则移动i向后(i++)。反之,移动j向前(j--)。如果当前的area大于了所记录的area,替换之。

这个想法的基础是,如果i的长度小于j,无论如何移动j,短板在i,不可能找到比当前记录的area更大的值了,只能通过移动i来找到新的可能的更大面积。

Attention: 巧妙之处,在于解决问题从一个最初的状态开始,为了达到最佳结果,应该怎么移动指针。我们总是会在这个过程中找到最后稳定的最佳结果。由于避免了一些不可能导致最大值的穷举值,所以降低了算法复杂度。这是一个贪心的策略,每次取两边围栏最矮的一个推进,希望获取更多的水。

AC Code:

class Solution {
public:
    int maxArea(vector<int> &height) {
        //求给定的n个高度两两能构成的最大面积。
        // S = min(ai, aj) * |i - j| (假定contaniner不是倾斜的 即取最短的高)
        
        int s = 0;
        int i = 0;
        int j = height.size() - 1;

        while(i < j)
        {
            s = max(s, (min(height[i], height[j]) * (j - i)));
            
            if(height[i] < height[j])
                i++;
            else
                j--;
        }
        
        return s;
        
    }
};


你可能感兴趣的:(LeetCode,array,Two,Pointers)